#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commdlg.h>
#include <shellapi.h>
#include <richedit.h>
#include <commctrl.h>
#include "akelpad.h"
#include "edit.h"


//Process
HANDLE hHeap;

//WinMain
HINSTANCE hInstance;
char *lpCmdLine;
int nCmdShow;
STARTUPINFO lpStartupInfo;

//Versions
BOOL bOldWindows;
BOOL bOldRichEdit;
BOOL bOldComctl32;

//Buffers
char buf[BUFFER_SIZE];
char buf2[BUFFER_SIZE];
unsigned char pcTranslateBuffer[TRANSLATE_BUFFER_SIZE];

//Language
char szLangModule[MAX_PATH]="";
HMODULE hLangLib;
int nLangModules=0;
LANGID wSystemLanguage;

//Main Window
HWND hMainWnd;
HWND hWndEdit;
HWND hSyncWindow;
HWND hStatus;
HWND hDlgModeless=0;
RECT rcMainWindow={CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT};
int nMainStyle=0;
int nLastMainSize=0;
int nStatusHeight=0;
HACCEL hMainAccel;
HICON hMainIcon;
HICON hIconEmpty;
HMENU hMainMenu;
HMENU hPopupMenu;
HMENU hPopupEdit;
HMENU hPopupView;

//Codepages
int codepages[65536];
BOOL bEnumCodePages=FALSE;
BOOL bDefaultBOM;
BOOL bCurrentBOM;
int nRecodeCodePage;
int nCurrentCodePage;
int nDefaultCodePage;
int nAnsiCodePage;
int nOemCodePage;
BOOL (WINAPI *GetCPInfoExPtr) (UINT, DWORD, LPCPINFOEX);

//Recent files
char szCurrentFile[MAX_PATH]="";
int nRecentFiles=RECENTFILES_AMOUNT;
char (*szRecentNames)[MAX_PATH]=NULL;
DWORD *szRecentPositions=NULL;
DWORD *szRecentCodepages=NULL;

//Open/Save dialog
OPENFILENAME ofn;
char szFileBuffer[FILELIST_BUFFER_SIZE];
char szFilter[MAX_PATH];
BOOL bAutodetect=TRUE;
BOOL bSaveDlg;
DWORD dwOfnFlags;
BOOL bOfnBOM=FALSE;
int nOfnCodePage;
BOOL bNewLineDetected;
WNDPROC OldPreviewProc;

//Find/Replace dialog
DWORD ftflags=FR_DOWN;
BOOL bRecodeDlg;
BOOL bReplaceDlg;
int nReplaceCount;
int nSearchStrings=SEARCHSTRINGS_AMOUNT;
wchar_t *wszFind_orig=NULL;
wchar_t *wszReplace_orig=NULL;
wchar_t *wszFind=NULL;
wchar_t *wszReplace=NULL;

//Options dialog
PROPSHEETHEADER psh={0};
PROPSHEETPAGE psp[2]={0};
HHOOK cbtHook;

//Font/Color
LOGFONT logfont;
CHOOSEFONT cf;
CHOOSECOLOR cc;
COLORREF crBackground=RGB(0xFF, 0xFF, 0xFF);
COLORREF crFont=RGB(0x00, 0x00, 0x00);
COLORREF crCustColors[16]={0};

//Print
PAGESETUPDLG psdPage={0};
PRINTDLG pd={0};
BOOL bGlobalPrint=FALSE;

//Edit position
CHARRANGE chrg={0, 0};
int nPosition=0;
int nPositionOld=0;
int nMaxChars=0x0FFFFFFF;
int nMcstep=0x0FFFFFFF;

//Edit state
BOOL bModified=FALSE;
BOOL bInsertState=FALSE;
BOOL bUnixNewLine=FALSE;
BOOL bWordWrap=FALSE;
BOOL bOnTop=FALSE;
BOOL bStatusBar=TRUE;
BOOL bSaveTime=FALSE;
BOOL bSingleOpenFile=FALSE;
BOOL bSingleOpenProgram=TRUE;
BOOL bKeepSpace=FALSE;
DWORD dwEditMargins=EDITMARGINS;

//Word breaking
wchar_t wszDelimiters[DELIMITERS_SIZE]=WORD_DELIMITERSW;
BOOL bFirstWordBreak=TRUE;

//Execute
char szCommand[BUFFER_SIZE]="";
char szExeDir[MAX_PATH]="";

//Associations
char szFileTypesOpen[MAX_PATH]=ASSOCIATE_OPEN;
char szFileTypesEdit[MAX_PATH]=ASSOCIATE_EDIT;
char szFileTypesPrint[MAX_PATH]=ASSOCIATE_PRINT;
DWORD dwFileTypesAssociated=0;

//Registered messages
UINT uiOpenOnStartMessage;

//Mdi
BOOL bMDI=FALSE;
BOOL bRegMDI=FALSE;
HWND hMdiClient;
HWND hWndMdiActive=0;
HWND hWndMdiDestroyed=0;
BOOL bMdiMaximize;
BOOL bMdiNoWindows=FALSE;
BOOL bMdiReopen=FALSE;
HWND hTab;
HFONT hTabFont;
LOGFONT tabfont;
int nTabView=TAB_VIEW_TOP;
int nTabType=TAB_TYPE_STANDART;
HIMAGELIST hImageList;
BOOL bFileExitError;
int nMdiStyle=WS_MAXIMIZE;
WNDPROC OldMdiClientProc;
WNDPROC OldTabProc;
MDIWINDOWDATA *lpWindowData;
UINT (WINAPI *ExtractIconExWPtr) (LPCWSTR, int, HICON *, HICON *, UINT);

void _WinMain()
{
  WNDCLASS wndclass={0};
  MSG msg;
  BOOL msgstatus;
  HMODULE hKernel32=0;
  HMODULE hShell32=0;
  HMODULE hRTFLib=0;
  OSVERSIONINFO osvi;
  HWND hWndFriend;
  int nMajor;
  int nMinor;
  int nRelease;
  int nBuild;
  int i;

  //Get process heap
  hHeap=GetProcessHeap();

  //Set default options before reading from registry
  GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &logfont);
  nAnsiCodePage=GetACP();
  nOemCodePage=GetOEMCP();
  nDefaultCodePage=nAnsiCodePage;
  nRecodeCodePage=nOemCodePage;
  bDefaultBOM=FALSE;
  wSystemLanguage=GetUserDefaultLangID();

  if (GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_IMEASURE, buf, 16))
  {
    if (*buf == '0')
    {
      psdPage.rtMargin.left=1000;
      psdPage.rtMargin.right=1000;
      psdPage.rtMargin.top=1000;
      psdPage.rtMargin.bottom=1000;
      psdPage.Flags=PSD_INHUNDREDTHSOFMILLIMETERS;
    }
    else
    {
      psdPage.rtMargin.left=500;
      psdPage.rtMargin.right=500;
      psdPage.rtMargin.top=500;
      psdPage.rtMargin.bottom=500;
      psdPage.Flags=PSD_INTHOUSANDTHSOFINCHES;
    }
  }

  //Read options
  RegReadOptions();

  if (nDefaultCodePage == CP_UNICODE_UCS2_LE || nDefaultCodePage == CP_UNICODE_UCS2_BE || nDefaultCodePage == CP_UNICODE_UTF8)
    bDefaultBOM=TRUE;
  bCurrentBOM=bDefaultBOM;
  nCurrentCodePage=nDefaultCodePage;
  bMDI=bRegMDI;

  //Get Windows version
  osvi.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
  GetVersionEx(&osvi);
  if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT)
    bOldWindows=FALSE;
  else
    bOldWindows=TRUE;

  //Get rich edit version
  GetFileVersion("riched20.dll", &nMajor, &nMinor, &nRelease, &nBuild);
  if (nMajor < 5 || (nMajor == 5 && nMinor < 30))
    bOldRichEdit=TRUE;
  else
    bOldRichEdit=FALSE;

  //Get common controls version
  GetFileVersion("comctl32.dll", &nMajor, &nMinor, &nRelease, &nBuild);
  if (nMajor < 4 || (nMajor == 4 && nMinor < 71))
    bOldComctl32=TRUE;
  else
    bOldComctl32=FALSE;

  //Get standart WinMain info, because of own entry point.
  hInstance=GetModuleHandle(NULL);

  //Get command line
  lpCmdLine=GetCommandLineParamsA();

  //Get show window info
  lpStartupInfo.cb=sizeof(STARTUPINFO);
  GetStartupInfo(&lpStartupInfo);
  nCmdShow=lpStartupInfo.wShowWindow;
  if (!nCmdShow) nCmdShow=SW_SHOWNORMAL;

  //If allow only one instance specified
  if (bMDI && bSingleOpenProgram)
  {
    if (hWndFriend=FindWindow(APP_FULL_TITLE, NULL))
    {
      WORD wAtom;
      char *pCmdLine=lpCmdLine;

      if (GetWindowLong(hWndFriend, GWL_STYLE) & WS_MINIMIZE)
        ShowWindow(hWndFriend, SW_RESTORE);
      else
        SetForegroundWindow(hWndFriend);

      //Get command line arguments
      while (GetCommandLineArgA(pCmdLine, buf, &pCmdLine))
      {
        if (!lstrcmpi(buf, "/P"))
        {
          bGlobalPrint=TRUE;
          continue;
        }
        if (!*buf) continue;

        wAtom=GlobalAddAtom(buf);
        if (!bGlobalPrint)
          SendMessage(hWndFriend, WM_COMMAND, MAKELONG(IDM_NONMENU_FILEOPEN, wAtom), (LPARAM)MAKELONG(ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0));
        else
          SendMessage(hWndFriend, WM_COMMAND, MAKELONG(IDM_NONMENU_FILEPRINT, wAtom), (LPARAM)MAKELONG(ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0));
        GlobalDeleteAtom(wAtom);

        if (!bMDI) break;
        else continue;
      }
      goto Quit;
    }
  }

  //Get program directory
  i=GetModuleFileName(NULL, szExeDir, MAX_PATH);
  while (i > 0 && szExeDir[i] != '\\') --i;
  szExeDir[i]='\0';

  //GetOpenFileName dialog file filters
  API_LoadString(hLangLib, STR_FILE_FILTER, szFilter, MAX_PATH);
  for (i=0; szFilter[i]; ++i)
    if (szFilter[i] == '|') szFilter[i]='\0';
  szFilter[++i]='\0';

  //Load DLL's
  hKernel32=GetModuleHandle("kernel32.dll");
  GetCPInfoExPtr=(BOOL(WINAPI *)(UINT, DWORD, LPCPINFOEX))GetProcAddress(hKernel32, "GetCPInfoExA");

  if (!bOldWindows)
  {
    hShell32=GetModuleHandle("shell32.dll");
    ExtractIconExWPtr=(UINT(WINAPI *)(LPCWSTR, int, HICON *, HICON *, UINT))GetProcAddress(hShell32, "ExtractIconExW");
  }

  if (*szLangModule)
  {
    wsprintf(buf, "%s\\AkelFiles\\Langs\\%s", szExeDir, szLangModule);

    if (!(hLangLib=LoadLibrary(buf)))
    {
      hLangLib=hInstance;
      API_LoadString(hLangLib, MSG_ERROR_LOADING_LANG_DLL, buf, BUFFER_SIZE);
      wsprintf(buf2, buf, szLangModule);
      MessageBox(NULL, buf2, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
    }
  }
  else hLangLib=hInstance;

  if (!(hRTFLib=LoadLibrary("riched20.dll")))
  {
    API_LoadString(hLangLib, MSG_ERROR_LOADING_RICHEDIT_DLL, buf, BUFFER_SIZE);
    MessageBox(NULL, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
    goto Quit;
  }

  uiOpenOnStartMessage=RegisterWindowMessage("AkelPad Open-On-Start message");
  InitCommonControls();

  hMainAccel=API_LoadAccelerators(hLangLib, MAKEINTRESOURCE(IDM_MENU_MAIN));
  hMainIcon=API_LoadIcon(hLangLib, MAKEINTRESOURCE(IDI_ICON_MAIN));
  hIconEmpty=(HICON)API_LoadImage(hLangLib, MAKEINTRESOURCE(IDI_ICON_EMPTY), IMAGE_ICON, 0, 0, 0);
  hMainMenu=API_LoadMenu(hLangLib, MAKEINTRESOURCE(IDM_MENU_MAIN));
  hPopupMenu=API_LoadMenu(hLangLib, MAKEINTRESOURCE(IDM_MENU_POPUP));

  wndclass.style        =CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
  wndclass.lpfnWndProc  =WndProc;
  wndclass.cbClsExtra   =0;
  wndclass.cbWndExtra   =DLGWINDOWEXTRA;
  wndclass.hInstance    =hInstance;
  wndclass.hIcon        =hMainIcon;
  wndclass.hCursor      =NULL;
  wndclass.hbrBackground=(HBRUSH)GetStockObject(HOLLOW_BRUSH);
  wndclass.lpszMenuName =MAKEINTRESOURCE(IDM_MENU_MAIN);
  wndclass.lpszClassName=APP_FULL_TITLE;
  if (!RegisterClass(&wndclass)) goto Quit;

  if (!bMDI)
  {
    wndclass.style        =0;
    wndclass.lpfnWndProc  =DummyWndProc;
    wndclass.cbClsExtra   =0;
    wndclass.cbWndExtra   =DLGWINDOWEXTRA;
    wndclass.hInstance    =hInstance;
    wndclass.hIcon        =NULL;
    wndclass.hCursor      =NULL;
    wndclass.hbrBackground=NULL;
    wndclass.lpszMenuName =NULL;
    wndclass.lpszClassName=APP_DUMMY_NAME;
    if (!RegisterClass(&wndclass)) goto Quit;
  }
  else
  {
    wndclass.style        =CS_HREDRAW|CS_VREDRAW;
    wndclass.lpfnWndProc  =MdiProc;
    wndclass.cbClsExtra   =0;
    wndclass.cbWndExtra   =DLGWINDOWEXTRA;
    wndclass.hInstance    =hInstance;
    wndclass.hIcon        =NULL;
    wndclass.hCursor      =NULL;
    wndclass.hbrBackground=NULL;
    wndclass.lpszMenuName =NULL;
    wndclass.lpfnWndProc  =MdiProc;
    wndclass.lpszClassName=APP_MDI_NAME;
    if (!RegisterClass(&wndclass)) goto Quit;
  }

  hMainWnd=CreateWindow(APP_FULL_TITLE,        // window class name
                        APP_SHORT_TITLE,       // window caption
                        WS_OVERLAPPEDWINDOW,   // window style
                        rcMainWindow.left,     // initial x position
                        rcMainWindow.top,      // initial y position
                        rcMainWindow.right,    // initial x size
                        rcMainWindow.bottom,   // initial y size
                        NULL,                  // parent window handle
                        hMainMenu,             // window menu handle
                        hInstance,             // program instance handle
                        NULL);                 // creation parameters
  if (!hMainWnd) goto Quit;

  if (!bMDI)
  {
    hSyncWindow=CreateWindow(APP_DUMMY_NAME,        // window class name
                             "",                    // window caption
                             WS_POPUP,              // window style
                             CW_USEDEFAULT,         // initial x position
                             CW_USEDEFAULT,         // initial y position
                             CW_USEDEFAULT,         // initial x size
                             CW_USEDEFAULT,         // initial y size
                             hMainWnd,              // parent window handle
                             NULL,                  // window menu handle
                             hInstance,             // program instance handle
                             NULL);                 // creation parameters
  }

  UpdateWindow(hMainWnd);

  while ((msgstatus=GetMessage(&msg, NULL, 0, 0)) && msgstatus != -1)
  {
    if (hDlgModeless == 0 || !IsDialogMessage(hDlgModeless, &msg))
    {
      if (!TranslateAccelerator(hMainWnd, hMainAccel, &msg))
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
      }
    }
  }
  if (msgstatus == -1)
  {
    API_LoadString(hLangLib, MSG_ERROR_IN_MESSAGE_QUEUE, buf, BUFFER_SIZE);
    MessageBox(NULL, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
  }

  Quit:
  if (hRTFLib) FreeLibrary(hRTFLib);
  if (hLangLib && hLangLib != hInstance) FreeLibrary(hLangLib);
  ExitProcess(0);
}

LRESULT CALLBACK WndProc(HWND hMainWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LPARAM lMenuState;
  RECT rcRect;
  char *pName;
  int i;

  if (uMsg == uiOpenOnStartMessage)
  {
    HWND hWndFriend;
    char *pCmdLine=lpCmdLine;

    ofn.lStructSize      =sizeof(OPENFILENAME);
    ofn.hwndOwner        =hMainWnd;
    ofn.hInstance        =hLangLib;
    ofn.lpstrFile        =szFileBuffer;
    ofn.lpstrFilter      =szFilter;
    ofn.lpstrCustomFilter=NULL;
    ofn.nMaxCustFilter   =0;
    ofn.nFilterIndex     =2;
    ofn.nMaxFile         =FILELIST_BUFFER_SIZE;
    ofn.lpstrFileTitle   =NULL;
    ofn.nMaxFileTitle    =0;
    ofn.lpstrInitialDir  =NULL;
    ofn.lpstrTitle       =NULL;
    ofn.nFileOffset      =0;
    ofn.nFileExtension   =0;
    ofn.lCustData        =0;
    ofn.Flags            =OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_ENABLEHOOK|OFN_ENABLETEMPLATE|OFN_ENABLESIZING;
    ofn.lpfnHook         =CodePageDlgProc;
    ofn.lpTemplateName   =MAKEINTRESOURCE(IDD_OFN);

    cf.lStructSize   =sizeof(CHOOSEFONT);
    cf.hwndOwner     =hMainWnd;
    cf.hDC           =NULL;
    cf.lpLogFont     =&logfont;
    cf.iPointSize    =0;
    cf.rgbColors     =0;
    cf.lCustData     =0;
    cf.lpfnHook      =NULL;
    cf.lpTemplateName=NULL;
    cf.hInstance     =NULL;
    cf.lpszStyle     =NULL;
    cf.nFontType     =0;
    cf.nSizeMin      =0;
    cf.nSizeMax      =0;
    cf.Flags         =CF_FORCEFONTEXIST|CF_INITTOLOGFONTSTRUCT|CF_SCREENFONTS;

    cc.lStructSize   =sizeof(CHOOSECOLOR);
    cc.hwndOwner     =hMainWnd;
    cc.hInstance     =NULL;
    cc.lpCustColors  =crCustColors;
    cc.Flags         =CC_FULLOPEN|CC_RGBINIT;
    cc.lCustData     =0;
    cc.lpfnHook      =NULL;
    cc.lpTemplateName=NULL;

    psdPage.lStructSize=sizeof(PAGESETUPDLG);
    psdPage.hwndOwner  =hMainWnd;
    psdPage.Flags     |=PSD_MARGINS;

    pd.lStructSize=sizeof(PRINTDLG);
    pd.hwndOwner  =hMainWnd;
    pd.Flags      =PD_ALLPAGES|PD_NOPAGENUMS|PD_RETURNDC|PD_USEDEVMODECOPIESANDCOLLATE;
    pd.nCopies    =1;

    psp[0].dwSize     =sizeof(PROPSHEETPAGE);
    psp[0].dwFlags    =PSP_DEFAULT;
    psp[0].hInstance  =hLangLib;
    psp[0].pszTemplate=MAKEINTRESOURCE(IDD_OPTIONS_GENERAL);
    psp[0].pfnDlgProc =(DLGPROC)OptionsGeneralDlgProc;
    psp[1].dwSize     =sizeof(PROPSHEETPAGE);
    psp[1].dwFlags    =PSP_DEFAULT;
    psp[1].hInstance  =hLangLib;
    psp[1].pszTemplate=MAKEINTRESOURCE(IDD_OPTIONS_ADVANCED);
    psp[1].pfnDlgProc =(DLGPROC)OptionsAdvancedDlgProc;

    psh.dwSize     =(bOldComctl32)?(PROPSHEETHEADER_V1_SIZE):(sizeof(PROPSHEETHEADER));
    psh.dwFlags    =PSH_PROPSHEETPAGE|PSH_NOAPPLYNOW|PSH_USEICONID|PSH_USECALLBACK;
    psh.hwndParent =hMainWnd;
    psh.hInstance  =hLangLib;
    psh.pszIcon    =MAKEINTRESOURCE(IDI_ICON_MAIN);
    psh.nPages     =sizeof(psp) / sizeof(PROPSHEETPAGE);
    psh.nStartPage =0;
    psh.ppsp       =&psp[0];
    psh.pfnCallback=PropSheetProc;

    //Show main window
    ShowWindow(hMainWnd, (nMainStyle == WS_MAXIMIZE)?SW_SHOWMAXIMIZED:SW_SHOW);

    //Shortcut
    if (nCmdShow != SW_SHOWNORMAL)
      ShowWindow(hMainWnd, nCmdShow);

    //Create edit window
    if (!bMDI)
    {
      CreateEditWindow(hMainWnd);
    }
    else
    {
      GetClientRect(hMdiClient, &rcRect);
      CreateMDIWindow(APP_MDI_NAME, "", nMdiStyle, 0, 0, rcRect.right * 80 / 100, rcRect.bottom * 60 / 100, hMdiClient, hInstance, NULL);
    }

    //Allocate and read search string
    RegReadSearch();

    //Allocate and read recent files
    if (nRecentFiles)
    {
      if ((szRecentNames=(char (*)[MAX_PATH])API_HeapAlloc(hHeap, 0, nRecentFiles * MAX_PATH)) &&
          (szRecentPositions=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))) &&
          (szRecentCodepages=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))))
      {
        RecentFilesZero();
        RecentFilesRead();
      }
    }
    RecentFilesMenu();

    //Apply settings
    szCurrentFile[0]='\0';
    SetFocus(hWndEdit);
    SetUnixNewLine(FALSE, TRUE);
    SetInsertState(FALSE, TRUE);
    SetModify(FALSE, TRUE);
    SetCodePage(MAKELONG(nDefaultCodePage, bDefaultBOM), TRUE);
    DoViewOnTop(bOnTop, TRUE);
    DoViewShowStatusBar(bStatusBar, TRUE);
    DoSettingsSaveTime(bSaveTime);
    DoSettingsKeepSpace(bKeepSpace);
    DoSettingsSingleOpenFile(bSingleOpenFile);
    if (bMDI)
    {
      DoSettingsSingleOpenProgram(bSingleOpenProgram);
      DoWindowTabView(nTabView, TRUE);
      DoWindowTabType(nTabType, TRUE);
    }

    //Get command line arguments
    while (GetCommandLineArgA(pCmdLine, buf, &pCmdLine))
    {
      if (!lstrcmpi(buf, "/P"))
      {
        bGlobalPrint=TRUE;
        continue;
      }
      if (!*buf) continue;
      lstrcpy(szFileBuffer, buf);

      if (!bMDI)
      {
        if (bSingleOpenFile && GetFullPathName(szFileBuffer, BUFFER_SIZE, buf, &pName))
        {
          if ((hWndFriend=FindWindow(APP_DUMMY_NAME, buf)) && (hWndFriend=GetParent(hWndFriend)))
          {
            SetForegroundWindow(hWndFriend);
            DestroyWindow(hMainWnd);
            return TRUE;
          }
        }
        OpenDocument(szFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
        break;
      }
      else
      {
        OpenDocument(szFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
        continue;
      }
    }
  }

  if (uMsg == WM_CREATE)
  {
    int iSBParts[]={110, 220, 250, 280, -1};
    CLIENTCREATESTRUCT ccs;
    DWORD dwClassStyle;

    ShowWindow(hMainWnd, SW_HIDE);
    hPopupEdit=GetSubMenu(hPopupMenu, 0);
    hPopupView=GetSubMenu(hPopupMenu, 1);

    if (!bMDI)
    {
      DeleteMenu(hMainMenu, MDIMENU_POSITION, MF_BYPOSITION);
      DeleteMenu(hMainMenu, IDM_OPTIONS_SINGLEOPEN_PROGRAM, MF_BYCOMMAND);
      DragAcceptFiles(hMainWnd, TRUE);
    }
    else
    {
      GetClientRect(hMainWnd, &rcRect);

      //MDI Client
      ccs.hWindowMenu=GetSubMenu(hMainMenu, MDIMENU_POSITION);
      ccs.idFirstChild=ID_FIRSTMDI;

      hMdiClient=CreateWindow("MdiClient",
                              NULL,
                              WS_CHILD|WS_VISIBLE|WS_CLIPCHILDREN|WS_VSCROLL|WS_HSCROLL,
                              0, 0, rcRect.right, rcRect.bottom,
                              hMainWnd,
                              NULL,
                              hInstance,
                              (LPVOID)&ccs);

      dwClassStyle=GetClassLong(hMdiClient, GCL_STYLE);
      SetClassLong(hMdiClient, GCL_STYLE, dwClassStyle|CS_DBLCLKS);

      OldMdiClientProc=(WNDPROC)GetWindowLong(hMdiClient, GWL_WNDPROC);
      SetWindowLong(hMdiClient, GWL_WNDPROC, (LONG)NewMdiClientProc);

      DragAcceptFiles(hMdiClient, TRUE);

      //Tab Control
      hTab=CreateWindow("SysTabControl32",
                        0,
                        WS_CHILD|WS_VISIBLE|TCS_SINGLELINE|TCS_FOCUSNEVER,
                        0, 0, rcRect.right, TAB_HEIGHT,
                        hMainWnd,
                        (HMENU)ID_TAB,
                        hInstance,
                        0);

      OldTabProc=(WNDPROC)GetWindowLong(hTab, GWL_WNDPROC);
      SetWindowLong(hTab, GWL_WNDPROC, (LONG)NewTabProc);

      tabfont.lfHeight        =8;
      tabfont.lfWidth         =0;
      tabfont.lfEscapement    =0;
      tabfont.lfOrientation   =0;
      tabfont.lfWeight        =FW_NORMAL;
      tabfont.lfItalic        =0;
      tabfont.lfUnderline     =0;
      tabfont.lfStrikeOut     =0;
      tabfont.lfCharSet       =ANSI_CHARSET;
      tabfont.lfOutPrecision  =OUT_DEFAULT_PRECIS;
      tabfont.lfClipPrecision =CLIP_DEFAULT_PRECIS;
      tabfont.lfQuality       =DEFAULT_QUALITY;
      tabfont.lfPitchAndFamily=DEFAULT_PITCH;
      lstrcpy(tabfont.lfFaceName, "MS Sans Serif");

      hTabFont=CreateFontIndirect(&tabfont);
      SendMessage(hTab, WM_SETFONT, (WPARAM)hTabFont, (LPARAM)TRUE);

      hImageList=ImageList_Create(GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), ILC_COLOR32|ILC_MASK, 0, 0);
      ImageList_SetBkColor(hImageList, GetSysColor(COLOR_ACTIVEBORDER /*COLOR_BTNFACE*/));
      SendMessage(hTab, TCM_SETIMAGELIST, 0, (LPARAM)hImageList);
      SendMessage(hTab, TCM_SETEXTENDEDSTYLE, 0, TCS_EX_FLATSEPARATORS);
    }

    //Status Bar
    hStatus=CreateWindow("msctls_statusbar32",
                         "",
                         WS_CHILD|WS_VISIBLE|SBARS_SIZEGRIP,
                         0, 0, 0, 0,
                         hMainWnd,
                         (HMENU)ID_STATUS,
                         hInstance,
                         NULL);

    SendMessage(hStatus, SB_SIMPLE, FALSE, 0);
    SendMessage(hStatus, SB_SETPARTS, 5, (LPARAM)&iSBParts);

    GetWindowRect(hStatus, &rcRect);
    nStatusHeight=rcRect.bottom - rcRect.top;

    PostMessage(hMainWnd, uiOpenOnStartMessage, 0, 0);
  }
  else if (uMsg == WM_INITMENU)
  {
    LanguageMenu();
    lMenuState=SearchPath(NULL, "charmap.exe", NULL, BUFFER_SIZE, buf, &pName)?MF_ENABLED:MF_GRAYED;
    EnableMenuItem(hMainMenu, IDM_EDIT_INSERTCHAR, lMenuState);

    if (hWndEdit)
    {
      EnableMenuItem(hMainMenu, IDM_FILE_CREATENEW, (bMDI && bSingleOpenProgram)?MF_GRAYED:MF_ENABLED);
      EnableMenuItem(hMainMenu, IDM_FILE_REOPEN, (*szCurrentFile)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMainMenu, IDM_FILE_SAVE, (bModified || !*szCurrentFile)?MF_ENABLED:MF_GRAYED);

      lMenuState=(chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMainMenu, IDM_EDIT_CUT, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_COPY, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_CLEAR, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_UPPERCASE, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_LOWERCASE, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_SENTENCECASE, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_TITLECASE, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_INVERTCASE, lMenuState);

      lMenuState=(!DoEditInsertCharInSelection(hWndEdit, CHECK_STATE, 0))?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMainMenu, IDM_EDIT_INSERT_TAB_MENU, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_DELETE_TAB_MENU, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_INSERT_SPACE_MENU, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_DELETE_SPACE_MENU, lMenuState);

      lMenuState=(!DoEditDeleteTrailingWhitespaces(hWndEdit, CHECK_TRAILING_WHITESPACES))?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMainMenu, IDM_EDIT_DELETE_TRAILING_WHITESPACES_MENU, lMenuState);

      EnableMenuItem(hMainMenu, IDM_EDIT_UNDO, SendMessage(hWndEdit, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMainMenu, IDM_EDIT_REDO, SendMessage(hWndEdit, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMainMenu, IDM_EDIT_PASTE, SendMessage(hWndEdit, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);

      EnableMenuItem(hMainMenu, IDM_OPTIONS_EXEC, (*szCommand)?MF_ENABLED:MF_GRAYED);

      if (bOldComctl32) EnableMenuItem(hMainMenu, IDM_WINDOW_TABTYPE_FLATBUTTONS, MF_GRAYED);
    }
  }
  else if (uMsg == WM_MENUSELECT ||
           uMsg == WM_INITMENUPOPUP)
  {
    CheckMenuItem(hMainMenu, IDM_OPTIONS_SDI, bRegMDI?MF_UNCHECKED:MF_CHECKED);
    CheckMenuItem(hMainMenu, IDM_OPTIONS_MDI, bRegMDI?MF_CHECKED:MF_UNCHECKED);

    if (hWndEdit)
    {
      CheckMenuItem(hMainMenu, IDM_EDIT_NEWLINE_WIN, bUnixNewLine?MF_UNCHECKED:MF_CHECKED);
      CheckMenuItem(hMainMenu, IDM_EDIT_NEWLINE_UNIX, bUnixNewLine?MF_CHECKED:MF_UNCHECKED);
    }
  }
  else if (uMsg == WM_MOVE)
  {
    nMainStyle=GetWindowLong(hMainWnd, GWL_STYLE);

    if (!(nMainStyle & WS_MAXIMIZE) && !(nMainStyle & WS_MINIMIZE))
    {
      GetWindowRect(hMainWnd, &rcMainWindow);
      rcMainWindow.right-=rcMainWindow.left;
      rcMainWindow.bottom-=rcMainWindow.top;
    }
  }
  else if (uMsg == WM_SIZE)
  {
    if (wParam != SIZE_MAXIMIZED && wParam != SIZE_MINIMIZED)
    {
      GetWindowRect(hMainWnd, &rcMainWindow);
      rcMainWindow.right-=rcMainWindow.left;
      rcMainWindow.bottom-=rcMainWindow.top;
    }
    if (wParam != SIZE_MINIMIZED) nLastMainSize=wParam;

    SendMessage(hStatus, WM_SIZE, wParam, lParam);
    UpdateSize(LOWORD(lParam), HIWORD(lParam));
    return TRUE;
  }
  else if (uMsg == WM_DROPFILES)
  {
    if (SaveChanged())
    {
      nPosition=nPositionOld;
      DragQueryFile((HDROP)wParam, 0, szFileBuffer, FILELIST_BUFFER_SIZE);
      OpenDocument(szFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
      DragFinish((HDROP)wParam);
    }
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    if (bMDI)
    {
      if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
      CreateMDIWindow(APP_MDI_NAME, "", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDM_RECENT_FILES)
    {
      int nDead;

      RecentFilesRead();
      nDead=RecentFilesDeleteDead();
      RecentFilesSave();
      RecentFilesMenu();

      API_LoadString(hLangLib, MSG_RECENTFILES_DELETED, buf, BUFFER_SIZE);
      wsprintf(buf2, buf, nDead);
      MessageBox(hMainWnd, buf2, APP_SHORT_TITLE, MB_OK|MB_ICONINFORMATION);
      return TRUE;
    }
    if (LOWORD(wParam) > IDM_RECENT_FILES && LOWORD(wParam) <= IDM_RECENT_FILES + nRecentFiles)
    {
      if (SaveChanged())
      {
        lstrcpy(szFileBuffer, szRecentNames[LOWORD(wParam) - IDM_RECENT_FILES - 1]);
        OpenDocument(szFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
      }
      return TRUE;
    }
    if (LOWORD(wParam) >= IDM_LANGUAGE && LOWORD(wParam) <= IDM_LANGUAGE+nLangModules+1)
    {
      if (LOWORD(wParam) == IDM_LANGUAGE)
      {
        if (!*szLangModule) return TRUE;
        szLangModule[0]='\0';
      }
      else
      {
        GetMenuString(hMainMenu, LOWORD(wParam), buf, BUFFER_SIZE, MF_BYCOMMAND);
        wsprintf(buf2, "%s.dll", buf);
        if (!lstrcmpi(szLangModule, buf2)) return TRUE;
        lstrcpy(szLangModule, buf2);
      }
      API_LoadString(hLangLib, MSG_RESTART_PROGRAM, buf, BUFFER_SIZE);
      MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONEXCLAMATION);
      return TRUE;
    }

    if (LOWORD(wParam) == IDM_FILE_NEW)
    {
      DoFileNew();
    }
    else if (LOWORD(wParam) == IDM_FILE_CREATENEW)
    {
      if (!bMDI) RegSaveOptions();
      DoFileNewWindow();
    }
    else if (LOWORD(wParam) == IDM_FILE_OPEN)
    {
      DoFileOpen();
    }
    else if (LOWORD(wParam) == IDM_FILE_REOPEN)
    {
      DoFileReopenAs(0, nCurrentCodePage, bCurrentBOM);
    }
    else if (LOWORD(wParam) == IDM_FILE_SAVE)
    {
      DoFileSave();
    }
    else if (LOWORD(wParam) == IDM_FILE_SAVEAS)
    {
      DoFileSaveAs();
    }
    else if (LOWORD(wParam) == IDM_FILE_PAGESETUP)
    {
      DoFilePageSetup();
    }
    else if (LOWORD(wParam) == IDM_FILE_PRINT)
    {
      DoFilePrint();
    }
    else if (LOWORD(wParam) == IDM_FILE_EXIT)
    {
      PostMessage(hMainWnd, WM_CLOSE, 0, 0);
    }
    else if (LOWORD(wParam) == IDM_EDIT_UNDO)
    {
      DoEditUndo(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_REDO)
    {
      DoEditRedo(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_CUT)
    {
      DoEditCut(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_COPY)
    {
      DoEditCopy(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_PASTE)
    {
      DoEditPaste(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_PASTEANSI)
    {
      DoEditPasteANSI(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_CLEAR)
    {
      DoEditClear(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_SELECTALL)
    {
      DoEditSelectAll(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INSERTCHAR)
    {
      DoEditInsertChar();
    }
    else if (LOWORD(wParam) == IDM_EDIT_RECODE)
    {
      DoEditRecode(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INSERT_TAB_MENU ||
             LOWORD(wParam) == IDM_EDIT_INSERT_TAB)
    {
      DoEditInsertCharInSelection(hWndEdit, CHAR_INSERT, '\t');
    }
    else if (LOWORD(wParam) == IDM_EDIT_DELETE_TAB_MENU ||
             LOWORD(wParam) == IDM_EDIT_DELETE_TAB)
    {
      DoEditInsertCharInSelection(hWndEdit, CHAR_DELETE, '\t');
    }
    else if (LOWORD(wParam) == IDM_EDIT_INSERT_SPACE_MENU ||
             LOWORD(wParam) == IDM_EDIT_INSERT_SPACE)
    {
      DoEditInsertCharInSelection(hWndEdit, CHAR_INSERT, ' ');
    }
    else if (LOWORD(wParam) == IDM_EDIT_DELETE_SPACE_MENU ||
             LOWORD(wParam) == IDM_EDIT_DELETE_SPACE)
    {
      DoEditInsertCharInSelection(hWndEdit, CHAR_DELETE, ' ');
    }
    else if (LOWORD(wParam) == IDM_EDIT_DELETE_TRAILING_WHITESPACES_MENU ||
             LOWORD(wParam) == IDM_EDIT_DELETE_TRAILING_WHITESPACES)
    {
      DoEditDeleteTrailingWhitespaces(hWndEdit, DELETE_TRAILING_WHITESPACES);
    }
    else if (LOWORD(wParam) == IDM_EDIT_UPPERCASE)
    {
      DoEditChangeCase(hWndEdit, UPPERCASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_LOWERCASE)
    {
      DoEditChangeCase(hWndEdit, LOWERCASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_SENTENCECASE)
    {
      DoEditChangeCase(hWndEdit, SENTENCECASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_TITLECASE)
    {
      DoEditChangeCase(hWndEdit, TITLECASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INVERTCASE)
    {
      DoEditChangeCase(hWndEdit, INVERTCASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_NEWLINE_WIN)
    {
      SetUnixNewLine(FALSE, FALSE);
      SetModify(TRUE, FALSE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_NEWLINE_UNIX)
    {
      SetUnixNewLine(TRUE, FALSE);
      SetModify(TRUE, FALSE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_FIND)
    {
      DoEditFind();
    }
    else if (LOWORD(wParam) == IDM_EDIT_FINDNEXTDOWN)
    {
      DoEditFindNextDown(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_FINDNEXTUP)
    {
      DoEditFindNextUp(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_REPLACE)
    {
      DoEditReplace();
    }
    else if (LOWORD(wParam) == IDM_EDIT_GOTOLINE)
    {
      DoEditGoToLine();
    }
    else if (LOWORD(wParam) == IDM_VIEW_FONT)
    {
      DoViewFont(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_VIEW_TEXT_COLOR)
    {
      DoViewTextColor(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_VIEW_BG_COLOR)
    {
      DoViewBGColor(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_VIEW_DECREASE_FONT)
    {
      DoViewFontSize(hWndEdit, DECREASE_FONT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_INCREASE_FONT)
    {
      DoViewFontSize(hWndEdit, INCREASE_FONT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ALIGN_CENTER)
    {
      DoViewAlignment(hWndEdit, PFA_CENTER);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ALIGN_RIGHT)
    {
      DoViewAlignment(hWndEdit, PFA_RIGHT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ALIGN_LEFT)
    {
      DoViewAlignment(hWndEdit, PFA_LEFT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_WORDWRAP)
    {
      DoViewWordWrap(hWndEdit, !bWordWrap, FALSE);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ONTOP)
    {
      DoViewOnTop(!bOnTop, FALSE);
    }
    else if (LOWORD(wParam) == IDM_VIEW_SHOW_STATUSBAR)
    {
      DoViewShowStatusBar(!bStatusBar, FALSE);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_EXEC)
    {
      DoSettingsExec(szCommand);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SAVETIME)
    {
      DoSettingsSaveTime(!bSaveTime);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_KEEPSPACE)
    {
      DoSettingsKeepSpace(!bKeepSpace);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SINGLEOPEN_FILE)
    {
      DoSettingsSingleOpenFile(!bSingleOpenFile);
      RegSaveOptions();
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SINGLEOPEN_PROGRAM)
    {
      DoSettingsSingleOpenProgram(!bSingleOpenProgram);
      RegSaveOptions();
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SDI)
    {
      if (bRegMDI)
      {
        API_LoadString(hLangLib, MSG_RESTART_PROGRAM, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONEXCLAMATION);
        bRegMDI=FALSE;
      }
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_MDI)
    {
      if (!bRegMDI)
      {
        API_LoadString(hLangLib, MSG_RESTART_PROGRAM, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONEXCLAMATION);
        bRegMDI=TRUE;
      }
    }
    else if (LOWORD(wParam) == IDM_OPTIONS)
    {
      DoSettingsOptions();
    }
    else if (LOWORD(wParam) == IDM_ABOUT)
    {
      DoHelpAbout();
    }
    else if (LOWORD(wParam) == IDM_NONMENU_CHANGESIZE)
    {
      ShowWindow(hMainWnd, (GetWindowLong(hMainWnd, GWL_STYLE) & WS_MAXIMIZE)?SW_RESTORE:SW_MAXIMIZE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_DELLINE)
    {
      DoNonMenuDelLine(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_ANSI)
    {
      DoFileReopenAs(0, nAnsiCodePage, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_OEM)
    {
      DoFileReopenAs(0, nOemCodePage, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_UTF8)
    {
      DoFileReopenAs(ADT_DETECT_BOM, CP_UNICODE_UTF8, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_KOIR)
    {
      DoFileReopenAs(0, CP_KOI8_R, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_FILEOPEN ||
             LOWORD(wParam) == IDM_NONMENU_FILEPRINT)
    {
      if (bMDI || SaveChanged())
      {
        if (LOWORD(wParam) == IDM_NONMENU_FILEPRINT) bGlobalPrint=TRUE;
        GlobalGetAtomName(HIWORD(wParam), szFileBuffer, FILELIST_BUFFER_SIZE);
        OpenDocument(szFileBuffer, LOWORD(lParam), HIWORD(lParam), FALSE);
      }
    }

    if (bMDI)
    {
      if (LOWORD(wParam) == IDM_WINDOW_TABVIEW_TOP)
      {
        DoWindowTabView(TAB_VIEW_TOP, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABVIEW_BOTTOM)
      {
        DoWindowTabView(TAB_VIEW_BOTTOM, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABVIEW_NONE)
      {
        DoWindowTabView(TAB_VIEW_NONE, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABTYPE_STANDART)
      {
        DoWindowTabType(TAB_TYPE_STANDART, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABTYPE_BUTTONS)
      {
        DoWindowTabType(TAB_TYPE_BUTTONS, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABTYPE_FLATBUTTONS)
      {
        DoWindowTabType(TAB_TYPE_FLATBUTTONS, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TILEHORIZONTAL)
      {
        PostMessage(hMdiClient, WM_MDITILE, MDITILE_HORIZONTAL, 0);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TILEVERTICAL)
      {
        PostMessage(hMdiClient, WM_MDITILE, MDITILE_VERTICAL, 0);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_CASCADE)
      {
        PostMessage(hMdiClient, WM_MDICASCADE, 0, 0);
      }
      else if (LOWORD(wParam) == IDM_NONMENU_MDINEXT)
      {
        PostMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, TRUE);
      }
      else if (LOWORD(wParam) == IDM_NONMENU_MDIPREV)
      {
        PostMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, FALSE);
      }
      else if (LOWORD(wParam) == IDM_NONMENU_MDICLOSE)
      {
        PostMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
      }
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == ID_STATUS && (!bMDI || hWndMdiActive))
    {
      if (((NMHDR *)lParam)->code == NM_DBLCLK)
      {
        if (((LPNMMOUSE)lParam)->dwItemSpec == 0)
        {
          DoEditGoToLine();
        }
        else if (((LPNMMOUSE)lParam)->dwItemSpec == 2)
        {
          SendMessage(hWndEdit, WM_KEYDOWN, VK_INSERT, 0x00520001);
          SendMessage(hWndEdit, WM_KEYUP, VK_INSERT, 0xC0520001);
        }
        else if (((LPNMMOUSE)lParam)->dwItemSpec == 3)
        {
          SetUnixNewLine(!bUnixNewLine, FALSE);
          SetModify(TRUE, FALSE);
        }
      }
    }

    if (bMDI)
    {
      if (wParam == ID_TAB)
      {
        if (((NMHDR *)lParam)->code == TCN_SELCHANGE)
        {
          HWND hWnd;

          i=SendMessage(hTab, TCM_GETCURSEL, 0, 0);
          hWnd=GetDlgItem(hMdiClient, ID_FIRSTMDI + i);
          SendMessage(hMdiClient, WM_MDIACTIVATE, (WPARAM)hWnd, 0);
        }
      }
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    if (!bMDI)
    {
      if (!DoFileExit()) return TRUE;
      DestroyWindow(hWndEdit);
    }
    else
    {
      while (hWndMdiActive)
      {
        SendMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
        if (!bFileExitError) return TRUE;
      }
    }
    DestroyWindow(hMainWnd);
  }
  else if (uMsg == WM_DESTROY)
  {
    //Save options
    RegSaveOptions();

    //Clean up
    if (bMDI)
    {
      DeleteObject(hTabFont);
      ImageList_Destroy(hImageList);
    }
    DestroyAcceleratorTable(hMainAccel);
    DestroyIcon(hMainIcon);
    DestroyIcon(hIconEmpty);
    DestroyMenu(hMainMenu);
    DestroyMenu(hPopupMenu);
    FreeMemorySearch();
    FreeMemoryRecentFiles();

    PostQuitMessage(0);
  }

  if (!bMDI)
  {
    if (MdiProc(hMainWnd, uMsg, wParam, lParam) == TRUE) return TRUE;
    return DefWindowProc(hMainWnd, uMsg, wParam, lParam);
  }
  else
  {
    return DefFrameProc(hMainWnd, hMdiClient, uMsg, wParam, lParam);
  }
}

LRESULT CALLBACK MdiProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  NMHDR nmhdr;
  int nLine;
  int nColumn;
  int i;

  if (uMsg == WM_SETFOCUS)
  {
    SetFocus(hWndEdit);
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    if ((HWND)wParam == hWndEdit)
    {
      RECT rcRect;
      POINT pt;

      if (lParam == ((UINT)-1))
      {
        GetWindowRect((HWND)wParam, &rcRect);
        pt.x=rcRect.left;
        pt.y=rcRect.top;
      }
      else
      {
        pt.x=LOWORD(lParam);
        pt.y=HIWORD(lParam);
      }
      EnableMenuItem(hPopupEdit, IDM_EDIT_UNDO, SendMessage(hWndEdit, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_REDO, SendMessage(hWndEdit, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_CUT, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_COPY, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_PASTE, SendMessage(hWndEdit, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_CLEAR, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
      TrackPopupMenu(hPopupEdit, 0, pt.x, pt.y, 0, hMainWnd, NULL);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == ID_EDIT)
    {
      if (HIWORD(wParam) == EN_CHANGE)
      {
        SetModify(TRUE, FALSE);
      }
      else if (HIWORD(wParam) == EN_MAXTEXT)
      {
        //trying to reallocate
        API_LoadString(hLangLib, MSG_ERROR_LIMIT_REACHED, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
        nMaxChars+=nMcstep;
        SendMessage(hWndEdit, EM_EXLIMITTEXT, 0, nMaxChars);
      }
      else if (HIWORD(wParam) == EN_ERRSPACE)
      {
        API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY_FOR_RICHEDIT, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
        ExitProcess(1);
      }
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == ID_EDIT)
    {
      if (((NMHDR *)lParam)->code == EN_SELCHANGE)
      {
        CHARRANGE cr;
        int nLinebreaks=0;

        SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&cr);
        nPositionOld=nPosition;
        nPosition=(cr.cpMin == chrg.cpMin || cr.cpMin == chrg.cpMax)?cr.cpMax:cr.cpMin;
        chrg.cpMin=cr.cpMin;
        chrg.cpMax=cr.cpMax;

        nLine=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition) + 1;
        nColumn=SendMessage(hWndEdit, EM_LINEINDEX, nLine - 1, 0);
        nColumn=nPosition - nColumn + 1;

        if (chrg.cpMin == chrg.cpMax)
        {
          wsprintf(buf, "%u:%u", nLine, nColumn);
        }
        else
        {
          if (!bUnixNewLine) nLinebreaks=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, chrg.cpMax) - SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, chrg.cpMin);
          wsprintf(buf, "%u:%u, %u", nLine, nColumn, chrg.cpMax - chrg.cpMin + nLinebreaks);
        }
        SendMessage(hStatus, SB_SETTEXT, 0, (LPARAM)buf);
      }
      else if (((NMHDR *)lParam)->code == EN_MSGFILTER)
      {
        if (((MSGFILTER *)lParam)->msg == WM_KEYDOWN && ((MSGFILTER *)lParam)->wParam == VK_RETURN && bKeepSpace)
        {
          TEXTRANGE txtrng;
          int nMinLine;
          int nMinLineIndex;
          int textsize;
          int a;
          char *pText;

          nMinLine=SendMessage(hWndEdit, EM_LINEFROMCHAR, chrg.cpMin, 0);
          nMinLineIndex=SendMessage(hWndEdit, EM_LINEINDEX, nMinLine, 0);
          txtrng.chrg.cpMin=nMinLineIndex;
          txtrng.chrg.cpMax=chrg.cpMin;
          textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin;

          if (textsize)
          {
            if (pText=(char *)API_HeapAlloc(hHeap, 0, textsize + 2))
            {
              txtrng.lpstrText=pText + 1;
              SendMessage(hWndEdit, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);

              for (a=1, pText[0]='\n'; pText[a] == ' ' || pText[a] == '\t'; ++a);

              pText[a]='\0';
            }

            SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)pText);
            API_HeapFree(hHeap, 0, (LPVOID)pText);
            return TRUE;
          }
        }
        else if (((MSGFILTER *)lParam)->msg == WM_KEYDOWN && ((MSGFILTER *)lParam)->wParam == VK_INSERT)
        {
          if (GetKeyState(VK_SHIFT) >= 0 && GetKeyState(VK_CONTROL) >= 0)
          {
            SetInsertState(!bInsertState, FALSE);
          }
        }
        else if (((MSGFILTER *)lParam)->msg == WM_MOUSEWHEEL && LOWORD(((MSGFILTER *)lParam)->wParam) == MK_CONTROL)
        {
          if ((short)HIWORD(((MSGFILTER *)lParam)->wParam) < 0)
            DoViewFontSize(hWndEdit, DECREASE_FONT);
          else
            DoViewFontSize(hWndEdit, INCREASE_FONT);
          return TRUE;
        }
      }
    }
  }
  if (!bMDI) return FALSE;

  if (uMsg == WM_CREATE)
  {
    if (lpWindowData=(MDIWINDOWDATA *)API_HeapAlloc(hHeap, 0, sizeof(MDIWINDOWDATA)))
    {
      TCITEM tcItem;

      CreateEditWindow(hWnd);

      lpWindowData->hIcon=hIconEmpty;
      lpWindowData->bWordWrap=bWordWrap;
      lpWindowData->bUnixNewLine=FALSE;
      lpWindowData->bInsertState=FALSE;
      lpWindowData->bModified=FALSE;
      lpWindowData->nCodePage=MAKELONG(nDefaultCodePage, bDefaultBOM);
      SetWindowLong(hWnd, GWL_USERDATA, (LONG)lpWindowData);

      i=ImageList_AddIcon(hImageList, hIconEmpty);
      tcItem.mask=TCIF_TEXT|TCIF_IMAGE;
      tcItem.pszText="";
      tcItem.iImage=i;
      i=SendMessage(hTab, TCM_GETITEMCOUNT, 0, 0);
      SendMessage(hTab, TCM_INSERTITEM, i, (LPARAM)&tcItem);
      SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)hIconEmpty);

      if (!hWndMdiActive) InvalidateRect(hTab, NULL, TRUE);
    }
  }
  else if (uMsg == WM_SIZE)
  {
    if (wParam != SIZE_MINIMIZED)
      MoveWindow(GetDlgItem(hWnd, ID_EDIT), 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
  }
  else if (uMsg == WM_MDIACTIVATE)
  {
    int nMessages[]={IDM_FILE_REOPEN,
                     IDM_FILE_SAVE,
                     IDM_FILE_SAVEAS,
                     IDM_FILE_PAGESETUP,
                     IDM_FILE_PRINT,
                     IDM_EDIT_UNDO,
                     IDM_EDIT_REDO,
                     IDM_EDIT_CUT,
                     IDM_EDIT_COPY,
                     IDM_EDIT_PASTE,
                     IDM_EDIT_CLEAR,
                     IDM_EDIT_SELECTALL,
                     IDM_EDIT_FIND,
                     IDM_EDIT_FINDNEXTDOWN,
                     IDM_EDIT_FINDNEXTUP,
                     IDM_EDIT_REPLACE,
                     IDM_EDIT_GOTOLINE,
                     IDM_EDIT_INSERT_TAB_MENU,
                     IDM_EDIT_DELETE_TAB_MENU,
                     IDM_EDIT_INSERT_SPACE_MENU,
                     IDM_EDIT_DELETE_SPACE_MENU,
                     IDM_EDIT_DELETE_TRAILING_WHITESPACES_MENU,
                     IDM_EDIT_UPPERCASE,
                     IDM_EDIT_LOWERCASE,
                     IDM_EDIT_SENTENCECASE,
                     IDM_EDIT_TITLECASE,
                     IDM_EDIT_INVERTCASE,
                     IDM_EDIT_NEWLINE_WIN,
                     IDM_EDIT_NEWLINE_UNIX,
                     IDM_EDIT_RECODE,
                     IDM_VIEW_FONT,
                     IDM_VIEW_TEXT_COLOR,
                     IDM_VIEW_BG_COLOR,
                     IDM_VIEW_DECREASE_FONT,
                     IDM_VIEW_INCREASE_FONT,
                     IDM_VIEW_ALIGN_LEFT,
                     IDM_VIEW_ALIGN_CENTER,
                     IDM_VIEW_ALIGN_RIGHT,
                     IDM_VIEW_WORDWRAP,
                     IDM_WINDOW_TILEHORIZONTAL,
                     IDM_WINDOW_TILEVERTICAL,
                     IDM_WINDOW_CASCADE,
                     0};

    hWndEdit=GetDlgItem((HWND)lParam, ID_EDIT);

    if (!lParam)
    {
      for (i=0; nMessages[i]; ++i)
        EnableMenuItem(hMainMenu, nMessages[i], MF_GRAYED);
      bMdiNoWindows=TRUE;

      for  (i=0; i < 5; ++i)
        SendMessage(hStatus, SB_SETTEXT, i, (LPARAM)"");
      szCurrentFile[0]='\0';
    }
    else if (bMdiNoWindows)
    {
      for (i=0; nMessages[i]; ++i)
        EnableMenuItem(hMainMenu, nMessages[i], MF_ENABLED);
      bMdiNoWindows=FALSE;

      SetUnixNewLine(FALSE, TRUE);
      SetInsertState(FALSE, TRUE);
      SetModify(FALSE, TRUE);
      SetCodePage(MAKELONG(nDefaultCodePage, bDefaultBOM), TRUE);
    }

    if ((HWND)lParam != hWndMdiActive)
    {
      hWndMdiActive=(HWND)lParam;

      if (lParam && wParam && (HWND)wParam != hWndMdiDestroyed)
      {
        //Save deactivated MDI window settings
        lpWindowData=(MDIWINDOWDATA *)GetWindowLong((HWND)wParam, GWL_USERDATA);
        lpWindowData->bWordWrap=bWordWrap;
        lpWindowData->bUnixNewLine=bUnixNewLine;
        lpWindowData->bInsertState=bInsertState;
        lpWindowData->bModified=bModified;
        lpWindowData->nCodePage=MAKELONG(nCurrentCodePage, bCurrentBOM);
      }
      if (lParam)
      {
        //Set activated MDI window settings
        lpWindowData=(MDIWINDOWDATA *)GetWindowLong((HWND)lParam, GWL_USERDATA);
        bWordWrap=lpWindowData->bWordWrap;
        SetUnixNewLine(lpWindowData->bUnixNewLine, FALSE);
        SetInsertState(lpWindowData->bInsertState, FALSE);
        SetModify(lpWindowData->bModified, FALSE);
        SetCodePage(lpWindowData->nCodePage, FALSE);

        nmhdr.hwndFrom=hWndEdit;
        nmhdr.idFrom=ID_EDIT;
        nmhdr.code=EN_SELCHANGE;
        SendMessage((HWND)lParam, WM_NOTIFY, ID_EDIT, (LPARAM)&nmhdr);

        CheckMenuItem(hMainMenu, IDM_VIEW_WORDWRAP, bWordWrap?MF_CHECKED:MF_UNCHECKED);
        GetWindowText((HWND)lParam, szCurrentFile, MAX_PATH);

        i=GetWindowLong((HWND)lParam, GWL_ID);
        SendMessage(hTab, TCM_SETCURSEL, i - ID_FIRSTMDI, 0);
      }
    }
  }
  return DefMDIChildProc(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewMdiClientProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int nDropped;
  int i;

  if (uMsg == WM_DROPFILES)
  {
    nDropped=DragQueryFile((HDROP)wParam, 0xFFFFFFFF, szFileBuffer, FILELIST_BUFFER_SIZE);

    for (i=0; i < nDropped; ++i)
    {
      DragQueryFile((HDROP)wParam, i, szFileBuffer, FILELIST_BUFFER_SIZE);
      OpenDocument(szFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
    }
    DragFinish((HDROP)wParam);
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
    CreateMDIWindow(APP_MDI_NAME, "", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
  }
  else if (uMsg == WM_MDIDESTROY)
  {
    if (!(bFileExitError=DoFileExit())) return TRUE;

    i=SendMessage(hTab, TCM_GETCURSEL, 0, 0);
    SendMessage(hTab, TCM_REMOVEIMAGE, i, 0);
    SendMessage(hTab, TCM_DELETEITEM, i, 0);

    hWndMdiDestroyed=(HWND)wParam;
    SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
    DestroyWindow(GetDlgItem((HWND)wParam, ID_EDIT));

    lpWindowData=(MDIWINDOWDATA *)GetWindowLong((HWND)wParam, GWL_USERDATA);
    if (lpWindowData->hIcon != hIconEmpty) DestroyIcon(lpWindowData->hIcon);
    API_HeapFree(hHeap, 0, (LPVOID)lpWindowData);
  }
  return CallWindowProc(OldMdiClientProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewTabProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_CONTEXTMENU)
  {
    if (lParam != ((UINT)-1))
    {
      RECT rcRect;
      POINT pt;
      HMENU hMdiChildMenu;
      int i;

      pt.x=LOWORD(lParam);
      pt.y=HIWORD(lParam);
      GetWindowRect((HWND)wParam, &rcRect);
      SendMessage(hTab, WM_LBUTTONDOWN, 0, MAKELONG(pt.x - rcRect.left, pt.y - rcRect.top));
      SendMessage(hTab, WM_LBUTTONUP, 0, MAKELONG(pt.x - rcRect.left, pt.y - rcRect.top));
  
      hMdiChildMenu=GetSystemMenu(hWndMdiActive, FALSE);
      i=TrackPopupMenu(hMdiChildMenu, TPM_NONOTIFY|TPM_RETURNCMD, pt.x, pt.y, 0, hWndMdiActive, NULL);
      PostMessage(hWndMdiActive, WM_SYSCOMMAND, i, 0);
    }
    return TRUE;
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    PostMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
    return TRUE;
  }
  return CallWindowProc(OldTabProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK DummyWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
