#ifndef __EDIT_H__
#define __EDIT_H__

////Defines

#define APP_SHORT_TITLE            "AkelPad"
#define APP_FULL_TITLE             "AkelPad3"
#define APP_DUMMY_NAME             "AkelPad Synchronizing Class"
#define APP_MDI_NAME               "AkelPad Mdi Class"
#define APP_ABOUT_VERSION          "AkelPad 3.0.0 beta 5"
#define APP_HOMEPAGE               "http://akelpad.sf.net"
#define APP_ABOUT_EMAIL_KUZNETSOV  "developer@akelpad.net.ru"
#define APP_ABOUT_ICQ_KUZNETSOV    "109590531"
#define APP_ABOUT_EMAIL_SHENGALTS  "shengalts@mail.ru"

//Code pages strings
#define STR_SYSTEM_ANSI     "ANSI  (Windows)"
#define STR_SYSTEM_OEM      "OEM  (DOS)"
#define STR_UNICODE_UCS2_LE "1200  (UTF-16 LE)"
#define STR_UNICODE_UCS2_BE "1201  (UTF-16 BE)"
#define STR_UNICODE_UTF8    "65001 (UTF-8)"

//Code pages int
#define CP_UNICODE_UCS2_LE  1200
#define CP_UNICODE_UCS2_BE  1201
#define CP_UNICODE_UTF8     65001
#define CP_KOI8_R           20866

#ifndef IMF_AUTOFONTSIZEADJUST
  #define IMF_AUTOFONTSIZEADJUST 0x0010
#endif
#ifndef GT_SELECTION
  #define GT_SELECTION 2
#endif
#ifndef WM_MOUSEWHEEL
  #define WM_MOUSEWHEEL  0x020A
#endif

#define BUFFER_SIZE                1024
#define FILELIST_BUFFER_SIZE       8192
#define TRANSLATE_BUFFER_SIZE      8192
#define PREVIEW_SIZE               8188  //4094*2; -1 preview all file
#define DELIMITERS_SIZE            128
#define DETECTBINARY_SIZE          128
#define DETECTBOM_SIZE             4
#define RECENTFILES_AMOUNT         10
#define RECENTFILES_RECORD_LENGTH  90
#define SEARCHSTRINGS_AMOUNT       10
#define EDITMARGINS                MAKELONG(4, 4)
#define ASSOCIATE_OPEN             "txt;log;ini;inf"
#define ASSOCIATE_EDIT             "bat;cmd;reg;htm;html"
#define ASSOCIATE_PRINT            "txt;log;ini;inf"
#define WORD_DELIMITERSW          L" \t\r\\|[](){}<>,.;:+-=~!@#$%^&*/?'`\""
#define SENTENCE_SELIMITERS        "."
#define TITLE_DELIMITERS           " \t\r"

//OpenDocument flags
#define CODEPAGE_AUTODETECT 0
#define BOM_AUTODETECT      3

//Autodetect flags
#define ADT_BINARY_ERROR      0x00000001
#define ADT_REG_CODEPAGE      0x00000002
#define ADT_DETECT_CODEPAGE   0x00000004
#define ADT_DETECT_BOM        0x00000008

//Autodetect errors
#define EDT_OPEN          -1
#define EDT_ALLOC         -2
#define EDT_READ          -3
#define EDT_BINARY        -4
#define EDT_CANCEL        -5

//Search/Replace options
#define FR_UP           0x00100000
#define FR_BEGINNING    0x00200000
#define FR_SELECTION    0x00400000
#define FR_ESCAPESEQ    0x00800000

//Selection case
#define UPPERCASE    1
#define LOWERCASE    2
#define SENTENCECASE 3
#define TITLECASE    4
#define INVERTCASE   5

//Insert/Delete char in selection
#define CHECK_STATE                 1
#define CHAR_INSERT                 2
#define CHAR_DELETE                 3

//Delete trailing whitespaces in selection
#define CHECK_TRAILING_WHITESPACES  1
#define DELETE_TRAILING_WHITESPACES 2

//Change font size
#define DECREASE_FONT 1
#define INCREASE_FONT 2

//File types association
#define AE_ASSOCIATE     0x00000001
#define AE_DEASSOCIATE   0x00000002
#define AE_OPEN          0x00000004
#define AE_EDIT          0x00000008
#define AE_PRINT         0x00000010


////Structures

typedef struct _MDIWINDOWDATA {
  HICON hIcon;
  BOOL bWordWrap;
  BOOL bUnixNewLine;
  BOOL bInsertState;
  BOOL bModified;
  int nCodePage;
} MDIWINDOWDATA;

typedef struct _PASTEDATA {
  unsigned char *pData;
  int nLength;
} PASTEDATA;

typedef struct _STREAMDATA {
  HANDLE hFile;
  int nCodePage;
  int nBytes;
  int nBytesRead;
} STREAMDATA;


////Functions prototype

void CreateEditWindow(HWND hWnd);

BOOL DoFileNew();
void DoFileNewWindow();
BOOL DoFileOpen();
void DoFileReopenAs(DWORD Flags, int nCodePage, BOOL bBOM);
BOOL DoFileSave();
BOOL DoFileSaveAs();
void DoFilePageSetup();
void DoFilePrint();
BOOL DoFileExit();
void DoEditUndo(HWND hWnd);
void DoEditRedo(HWND hWnd);
void DoEditCut(HWND hWnd);
void DoEditCopy(HWND hWnd);
void DoEditPaste(HWND hWnd);
void DoEditPasteANSI(HWND hWnd);
void DoEditClear(HWND hWnd);
void DoEditSelectAll(HWND hWnd);
void DoEditInsertChar();
void DoEditRecode(HWND hWnd);
BOOL DoEditInsertCharInSelection(HWND hWnd, int nAction, char ch);
BOOL DoEditDeleteTrailingWhitespaces(HWND hWnd, int nAction);
void DoEditChangeCase(HWND hWnd, int nCase);
void DoEditFind();
void DoEditFindNextDown(HWND hWnd);
void DoEditFindNextUp(HWND hWnd);
void DoEditReplace();
void DoEditGoToLine();
void DoViewFont(HWND hWnd);
void DoViewTextColor(HWND hWnd);
void DoViewBGColor(HWND hWnd);
void DoViewFontSize(HWND hWnd, int nAction);
void DoViewAlignment(HWND hWnd, WORD wAlignment);
void DoViewOnTop(BOOL bState, BOOL bFirst);
void DoViewWordWrap(HWND hWnd, BOOL bState, BOOL bFirst);
void DoViewShowStatusBar(BOOL bState, BOOL bFirst);
void DoSettingsExec(char *pCommand);
void DoSettingsSaveTime(BOOL bState);
void DoSettingsSingleOpenFile(BOOL bState);
void DoSettingsSingleOpenProgram(BOOL bState);
void DoSettingsKeepSpace(BOOL bState);
void DoSettingsOptions();
void DoWindowTabView(int nView, BOOL bFirst);
void DoWindowTabType(int nType, BOOL bFirst);
void DoHelpAbout();
void DoNonMenuDelLine(HWND hWnd);

BOOL RegReadOptions();
BOOL RegSaveOptions();
void RegReadSearch();

int OpenDocument(char *szFile, DWORD Flags, int nCodePage, BOOL bBOM);
DWORD CALLBACK InputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
BOOL SaveDocument(char *szFile, int nCodePage, BOOL bBOM);
DWORD CALLBACK OutputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);

unsigned int CALLBACK CodePageDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewPreviewProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL RegEnumCodePages(int *codepages, int size);
void FillComboboxCodepage(HWND hWnd);
int GetComboboxCodepage(HWND hWnd);
int SelectComboboxCodepage(HWND hWnd, int nCodepage);
int FilePreview(HWND hWnd, char *pFile, int nPreviewBytes, DWORD Flags, int *nCodePage, BOOL *bBOM);
int AutodetectCodePage(char *pFile, DWORD dwBytesToCheck, DWORD Flags, int *nCodePage, BOOL *bBOM);
unsigned int UTF8toUTF16(const char *buf, unsigned int *len, wchar_t *tbuf, unsigned int tlen);
unsigned int UTF16toUTF8(const wchar_t *tbuf, unsigned int tlen, char *buf, unsigned int len);
void ChangeByteOrder(unsigned char *buf, unsigned int len);
unsigned int TranslateNewLinesToUnixW(wchar_t *tbuf, unsigned int *tlen);

BOOL CALLBACK FindAndReplaceDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void FillComboboxSearch(HWND hWndFind, HWND hWndReplace);
BOOL GetComboboxSearchText(HWND hWnd, wchar_t **wszText_orig, wchar_t **wszText);
void SaveComboboxSearch(HWND hWndFind, HWND hWndReplace);
int FindTextW(HWND hWnd);
int ReplaceTextW(HWND hWnd, BOOL all);
BOOL EscapeStringToEscapeDataW(wchar_t *input, wchar_t *output);
void EscapeDataToEscapeStringW(wchar_t *input, wchar_t *output);

void ReplaceSelA(HWND hWnd, char *pData);
void ReplaceSelW(HWND hWnd, wchar_t *pData);
DWORD CALLBACK ReplaceSelCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
int GetSelTextW(HWND hWnd, wchar_t **pText);
void FreeTextExW(wchar_t *pText);

BOOL CALLBACK GoToLineDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

void RecentFilesZero();
void RecentFilesRead();
BOOL RecentFilesGet(char *file, int *position, int *codepage);
BOOL RecentFilesUpdate(char *file, int position, int codepage);
int RecentFilesDeleteDead();
void RecentFilesSave();
void RecentFilesMenu();
int TrimPath(char *szResult, char *pPath, int nMax);

void LanguageMenu();

BOOL isInDelimiterList(wchar_t c);
int CALLBACK EditWordBreakProc(LPTSTR pchText, int ichCurrent, int cch, int code);

void RecodeText(HWND hWnd, int nCodePage);
BOOL CALLBACK RecodeDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK CBTProc(int iCode, WPARAM wParam, LPARAM lParam);
int CALLBACK PropSheetProc(HWND hDlg, UINT uMsg, LPARAM lParam);
BOOL CALLBACK OptionsGeneralDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK OptionsAdvancedDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

BOOL CALLBACK AboutDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

char* GetCommandLineParamsA();
int GetCommandLineArgA(char *lpCmdLine, char *szArg, char **lpNextArg);
void GetAssociatedIconA(char *pExt, char *szFile, int *nIconIndex, HICON *phiconLarge, HICON *phiconSmall);
void GetAssociatedIconW(wchar_t *pExt, wchar_t *wszFile, int *nIconIndex, HICON *phiconLarge, HICON *phiconSmall);
void AssociateFileTypes(char *pExts, char *pModule, DWORD Flags);
BOOL SaveChanged();
int SetLayout();
void RestoreLayout(int nLayout);
void SetChosenFont(HWND hWnd, LOGFONT logfont);
void SetChosenFontColor(HWND hWnd, COLORREF crFont);
void SetChosenFontSize(HWND hWnd, int nPixels);
int PixelsToTwips(HWND hWnd, int nPixels);
void SetModify(BOOL bState, BOOL bFirst);
void SetUnixNewLine(BOOL bState, BOOL bFirst);
void SetInsertState(BOOL bState, BOOL bFirst);
void SetCodePage(int nCodePage, BOOL bFirst);
BOOL FileExists(char *fname);
int IsFile(char *fname);
BOOL IsPathFull(char *fpath);
char* GetFileName(char *fname);
char* GetBaseName(char *pFile, char *szBaseName);
char* GetFileExtA(char *fname);
wchar_t* GetFileExtW(wchar_t *fname);
void GetFileVersion(char *pFile, int *nMajor, int *nMinor, int *nRelease, int *nBuild);
int ParseExecCommand(char *pCommand, char *szBuffer, int nBufferSize);
void UpdateSize(int nWidth, int nHeight);
void UpdateTitle(char *szFile);
void FreeMemorySearch();
void FreeMemoryRecentFiles();

HMENU API_LoadMenu(HINSTANCE hLoadInstance, LPCTSTR lpMenuName);
HACCEL API_LoadAccelerators(HINSTANCE hLoadInstance, LPCTSTR lpTableName);
HICON API_LoadIcon(HINSTANCE hLoadInstance, LPCTSTR lpIconName);
HANDLE API_LoadImage(HINSTANCE hLoadInstance, LPCTSTR lpszName, UINT uType, int cxDesired, int cyDesired, UINT fuLoad);
int API_LoadString(HINSTANCE hLoadInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax);
HWND API_CreateDialogA(HINSTANCE hLoadInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc);
HWND API_CreateDialogW(HINSTANCE hLoadInstance, LPCWSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc);
INT_PTR API_DialogBoxA(HINSTANCE hLoadInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc);
INT_PTR API_DialogBoxW(HINSTANCE hLoadInstance, LPCWSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc);
LPVOID API_HeapAlloc(HANDLE hHeap, DWORD dwFlags, SIZE_T dwBytes);
BOOL API_HeapFree(HANDLE hHeap, DWORD dwFlags, LPVOID lpMem);
HANDLE API_CreateFile(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile);
BOOL API_ReadFile(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped);
BOOL API_WriteFile(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped);
BOOL API_SetWindowTextW(HWND hWnd, LPCWSTR lpString);
int API_lstrlenW(LPCWSTR lpString);
int API_lstrcmpW(LPCWSTR lpString1, LPCWSTR lpString2);
int API_lstrcmpiW(LPCWSTR lpString1, LPCWSTR lpString2);

#endif
